//RahmenFinden_205d.js
// 12.08.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Zeigt Rahmen an, welchen eine bestimmte Farbe zugewiesen ist

// vorsichtshalber die Dialoge einschalten
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// die Programmversion feststellen
var appVers = app.version[0];
if (appVers != 4) {
	if (appVers == 5) {
		alert ("Fr InDesign CS3\nbitte die entsprechende Version des Scripts benutzen.", "Achtung");
	}
	else if (appVers == 6) {
		alert ("Fr InDesign CS4\nbitte die entsprechende Version des Scripts benutzen.", "Achtung");
	}
	else {
		alert ("Dieses Script nur mit InDesign CS2 benutzen.", "Achtung");
	}
	exit();
}

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

curDoc = app.documents[0];
zoomFactor = app.activeWindow.zoomPercentage;

// die benutzerdefinierten Farbfelder auflisten
var allSwatches = curDoc.swatches;
var curSwatch, cName;
var colorList = new Array();
for (var i=0; i<allSwatches.length; i++) {
	curSwatch = allSwatches.item(i);
	cName = curSwatch.name;
	if (cName != "None" && cName != "Black" && cName != "Paper" && cName != "Registration") {
		colorList.push(cName);
	}
}

// Dialoge, welche eventuell im Speicher geblieben sind, lschen
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// die zu suchende Farbe verlangen
var aDialog = app.dialogs.add({name:"Vorhandene Farbfelder", canCancel:true});
with (aDialog) {
	with (dialogColumns.add()) {
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Die zu suchende Farbe whlen"});
				var colorNames = dropdowns.add({stringList:colorList, selectedIndex:0, minWidth:130});
			}
		}
	}
}

// den Dialog zeigen
if (aDialog.show() == true) {
	var selColor, aOffset, aTint;
	// die Wahl des Anwenders bernehmen
	// der Name der Farbe ist das Element 'selectedIndex' der Liste 'colorList'
	selColor = colorList[colorNames.selectedIndex];
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}

// die Rahmen
var allFrames = curDoc.allPageItems;
var nFrames = allFrames.length;
var curFrame, curProps, curStory, tsr, nTsr;
var tmpCtr, frameType, imgOkay;
var txtCtr = insCtr = unaCtr = imgCtr = linCtr = uknCtr = grpCtr = 0;
var curInsPoint, whatKind;
for (var i=0; i<nFrames; i++) {
	tmpCtr = 0;
	curFrame = allFrames[i];
	curProps = curFrame.properties;
	imgOkay = false;
	aShadow = false;
	if (curFrame == "[object TextFrame]") {
		if (curProps.fillColor != undefined) {
			if (curProps.fillColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.strokeColor != undefined) {
			if (curProps.strokeColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.gapColor != undefined) {
			if (curProps.gapColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.shadowColor != undefined) {
			if (curProps.shadowColor.name == selColor) {
				tmpCtr++;
				aShadow = true;
			}
		}
		if (tmpCtr > 0) {
			txtCtr++;
			selectIt(curFrame, curProps, "Textrahmen");
		}
		if (tmpCtr == 0) {
			curStory = curFrame.parentStory;
			tsr = curStory.textStyleRanges;
			nTsr = tsr.length;
			if (nTsr == 0) {
				curInsPoint = curStory.insertionPoints[0];
				whatKind = "";
				for (var m=0; m<1; m++) {
					if (curInsPoint.fillColor != undefined) {
						if (curInsPoint.fillColor.name == selColor) { insCtr++; whatKind = "Fllfarbe:"; break; }}
					if (curInsPoint.strokeColor != undefined) {
						if (curInsPoint.strokeColor.name == selColor) { insCtr++; whatKind = "Kontur:"; break; }}
					if (curInsPoint.underlineColor != undefined) {
						if (curInsPoint.underlineColor.name == selColor) { insCtr++; whatKind = "Unterstreichung:"; break; }}
					if (curInsPoint.strikeThroughColor != undefined) {
						if (curInsPoint.strikeThroughColor.name == selColor) { insCtr++; whatKind = "Durchstreichung:"; break; }}
					if (curInsPoint.underlineGapColor != undefined) {
						if (curInsPoint.underlineGapColor.name == selColor) { insCtr++; whatKind = "Unterstreichung (Lcke):"; break; }}
					if (curInsPoint.strikeThroughGapColor != undefined) {
						if (curInsPoint.strikeThroughGapColor.name == selColor) { insCtr++; whatKind = "Durchstreichung (Lcke):"; break; }}
				}
				if (whatKind != "") {
					selectIt(curFrame, whatKind, "Einfgemarke");
				}
			}
		}
	}
	else if (curFrame == "[object Rectangle]" || curFrame == "[object Oval]" || curFrame == "[object Polygon]") {
		if (curProps.contentType == 1970168179) {
			if (curProps.fillColor != undefined) {
				if (curProps.fillColor.name == selColor) {
					tmpCtr++;
				}
			}
			if (curProps.strokeColor != undefined) {
				if (curProps.strokeColor.name == selColor) {
					tmpCtr++;
				}
			}
			if (curProps.gapColor != undefined) {
				if (curProps.gapColor.name == selColor) {
					tmpCtr++;
				}
			}
			if (curProps.shadowColor != undefined) {
				if (curProps.shadowColor.name == selColor) {
					tmpCtr++;
					aShadow = true;
				}
			}
			if (tmpCtr > 0) {
				unaCtr++;
				selectIt(curFrame, curProps, "Rahmen ohne Inhalt");
			}
		}
		else {
			frameType = "Bildrahmen";
			if (curProps.fillColor != undefined) {
				if (curProps.fillColor.name == selColor) {
					tmpCtr++;
				}
			}
			if (curProps.strokeColor != undefined) {
				if (curProps.strokeColor.name == selColor) {
					tmpCtr++;
				}
			}
			if (curProps.gapColor != undefined) {
				if (curProps.gapColor.name == selColor) {
					tmpCtr++;
				}
			}
			if (curProps.shadowColor != undefined) {
				if (curProps.shadowColor.name == selColor) {
					tmpCtr++;
					aShadow = true;
				}
			}
			if (tmpCtr == 0) { frameType = "Bild" }
			try {
				if (curFrame.graphics[0].properties.fillColor != undefined) {
					if (curFrame.graphics[0].properties.fillColor.name == selColor) {
						imgOkay = true;
						tmpCtr++;
					}
				}
			}
			catch (e) {
			}
			if (tmpCtr > 0) {
				imgCtr++;
				selectIt(curFrame, curProps, frameType, imgOkay);
			}
		}
	}
	else if (curFrame == "[object GraphicLine]") {
		if (curProps.fillColor != undefined) {
			if (curProps.fillColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.strokeColor != undefined) {
			if (curProps.strokeColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.gapColor != undefined) {
			if (curProps.gapColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.shadowColor != undefined) {
			if (curProps.shadowColor.name == selColor) {
				tmpCtr++;
				aShadow = true;
			}
		}
		if (tmpCtr > 0) {
			linCtr++;
			selectIt(curFrame, curProps, "Linienrahmen");
		}
	}
	else if (curFrame == "[object Group]") {
		// die Elemente der Gruppen sind zwei Mal vorhanden, 
		// deshalb wird nur der Schatten getestet;
		if (curProps.shadowColor != undefined) {
			if (curProps.shadowColor.name == selColor) {
				grpCtr++;
				selectIt(curFrame, curProps, "Gruppe");
			}
		}
	}
	else {
		if (curProps.fillColor != undefined) {
			if (curProps.fillColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.strokeColor != undefined) {
			if (curProps.strokeColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.gapColor != undefined) {
			if (curProps.gapColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.shadowColor != undefined) {
			if (curProps.shadowColor.name == selColor) {
				tmpCtr++;
				aShadow = true;
			}
		}
		if (tmpCtr > 0) {
			uknCtr++;
			selectIt(curFrame, curProps, "Unbekannt");
		}
	}
}

// die Tabellen
tabCtr = oldCtr = 0;
var allStories = curDoc.stories;
var nStories = allStories.length;
var allCells, allColors, curTest, nCells;
var nTables, curTable;
for (var i=0; i<nStories; i++) {
	nTables = allStories[i].tables.length;
	for (var k=0; k<nTables; k++) {
		curTable = allStories[i].tables[k];
		for (m=0; m<1; m++) {
			if (curTable.topBorderStrokeColor != undefined) {
				if (curTable.topBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.leftBorderStrokeColor != undefined) {
				if (curTable.leftBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.bottomBorderStrokeColor != undefined) {
				if (curTable.bottomBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.rightBorderStrokeColor != undefined) {
				if (curTable.rightBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.topBorderStrokeGapColor != undefined) {
				if (curTable.topBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			if (curTable.leftBorderStrokeGapColor != undefined) {
				if (curTable.leftBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			if (curTable.bottomBorderStrokeGapColor != undefined) {
				if (curTable.bottomBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			if (curTable.rightBorderStrokeGapColor != undefined) {
				if (curTable.rightBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			
			allCells = curTable.cells.everyItem();
			allColors = allCells.fillColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.topEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.leftEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.bottomEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.rightEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.diagonalLineStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.topEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.leftEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.bottomEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.rightEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.diagonalLineStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			
			allColors = allCells.texts[0].textStyleRanges.everyItem().fillColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.texts[0].textStyleRanges.everyItem().strokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			
			allColors = allCells.insertionPoints[0].fillColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.insertionPoints[0].strokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
		}
	}
	if (oldCtr < tabCtr) {
		oldCtr = tabCtr;
		selectIt(curTable, "", "Tabelle");
	}
}

// der Handler, welcher die Farben prft
function testItems(allColors) {
	nCol = allColors.length;
	for (c=0; c<nCol; c++) {
		try {
			if (allColors[c].name == selColor) {
				return true;
			}
		}
		catch (e) {
		}
	}
	return false;
}

// den Anwender informieren
var totCtr = txtCtr + insCtr + imgCtr + unaCtr + linCtr + uknCtr + tabCtr + grpCtr;
if (totCtr == 0) {
	alert ("Die Farbe  \"" + selColor + "\"\n\nist unauffindbar.", "Stop");
}

// selectIt-function (thanks to Dave Saunders)
// http://jsid.blogspot.com/2006/01/better-view-after-find.html
function selectIt(curFrame, curProps, frameType, imgOkay) {
	app.select(curFrame, SelectionOptions.replaceWith);
	app.activeWindow.zoomPercentage = zoomFactor;
	showInfos(curFrame, curProps, frameType, imgOkay);
}

function showInfos(curFrame, curProps, frameType, imgOkay) {
	if (frameType != "Tabelle" && frameType != "Gruppe" && frameType != "Einfgemarke") {
		if (curProps.fillColor != undefined) {
			var curFill = curProps.fillColor.name;
			if (curFill == "None") { curFill = "[Keine]"; }
			else if (curFill == "Paper") { curFill = "[Papier]"; }
			else if (curFill == "Black") { curFill = "[Schwarz]"; }
			else if (curFill == "Registration") { curFill = "[Passermarken]"; }
		}
		else {
			curFill = "undefiniert";
		}
		if (curProps.strokeColor != undefined) {
			var curStrk = curProps.strokeColor.name;
			if (curStrk == "None") { curStrk = "[Keine]"; }
			else if (curStrk == "Paper") { curStrk = "[Papier]"; }
			else if (curStrk == "Black") { curStrk = "[Schwarz]"; }
			else if (curStrk == "Registration") { curStrk = "[Passermarken]"; }
		}
		else {
			curStrk = "undefiniert";
		}
		if (curProps.gapColor != undefined) {
			var curGap = curProps.gapColor.name;
			if (curGap == "None") { curGap = "[Keine]"; }
			else if (curGap == "Paper") { curGap = "[Papier]"; }
			else if (curGap == "Black") { curGap = "[Schwarz]"; }
			else if (curGap == "Registration") { curGap = "[Passermarken]"; }
		}
		else {
			curGap = "undefiniert";
		}
	}
	var labelWidth = 80;
	var aDialog = app.dialogs.add({name:frameType});
	with (aDialog.dialogColumns.add()) {
		if (frameType != "Tabelle" && frameType != "Gruppe" && frameType != "Einfgemarke") {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Fllfarbe:", minWidth:labelWidth});
				staticTexts.add({staticLabel:curFill});
			}
			with (dialogRows.add()){
				staticTexts.add({staticLabel:"Kontur:", minWidth:labelWidth});
				staticTexts.add({staticLabel:curStrk});
			}
			if (curGap == selColor) {
				with (dialogRows.add()){
					staticTexts.add({staticLabel:"Lcke:", minWidth:labelWidth});
					staticTexts.add({staticLabel:curGap});
				}
			}
			if (aShadow) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Schatten:", minWidth:labelWidth});
					staticTexts.add({staticLabel:selColor});
				}
			}
			if (imgOkay) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Bild:", minWidth:labelWidth});
					staticTexts.add({staticLabel:selColor});
				}
			}
		}
		else if (frameType == "Tabelle") {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Die Farbe ...", minWidth:labelWidth});
				staticTexts.add({staticLabel:selColor});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"... wird", minWidth:labelWidth});
				staticTexts.add({staticLabel:"verwendet"});
			}
		}
		else if (frameType == "Gruppe") {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Die Farbe ...", minWidth:labelWidth});
				staticTexts.add({staticLabel:selColor});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"... wird als", minWidth:labelWidth});
				staticTexts.add({staticLabel:"Schatten benutzt"});
			}
		}
		else if (frameType == "Einfgemarke") {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:curProps, minWidth:labelWidth});
				staticTexts.add({staticLabel:selColor});
			}
		}
	}
	if (aDialog.show()) {
		aDialog.destroy();
	}
	else {
		aDialog.destroy();
		exit();
	}
}